/* -*- MaTX -*-
 *
 * tmd00021.h: TMD No. tmd00021 ۥ-ϥ쥤ǥΥإåե
 *
 *  Originally written by KIYOTA Hiromitsu <1999/05/30>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00021.h,v 1.1 1999/05/31 03:05:01 kiyota Exp $
 */

#ifndef _TMD00021_H
#define _TMD00021_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00021_USER_H
#include TMD00021_USER_H
#endif /* TMD00021_USER_H */

#ifndef TMD00021_MM
#define TMD00021_MM "tmd00021.mm"
#endif /* !TMD00021_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00021(var) _tmd00021_ ## var
#else /* ! TMD_ANSI */
#define tmd00021(var) _tmd00021_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00021(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ(x)(u)(y)μο
#define TMD00021_DIM_STATE 4
#define TMD00021_DIM_INPUT 1
#define TMD00021_DIM_OUTPUT 1
#define TMD00021_DIM_ALL_IOS (TMD00021_DIM_INPUT+TMD00021_DIM_OUTPUT)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00021(xx) [xx(1:TMD00021_DIM_STATE)]
#define chop_other_state_tmd00021(xx) [xx(TMD00021_DIM_STATE+1:)]
#define chop_input_tmd00021(uu) [uu(1:TMD00021_DIM_INPUT)]

// ǥ(ʪ)ѥ᡼
TMD_EXTERN Real tmd00021(CM);
TMD_EXTERN Real tmd00021(gNa_hat), tmd00021(gK_hat), tmd00021(gl_hat);
TMD_EXTERN Real tmd00021(VNa), tmd00021(VK), tmd00021(Vl);

// ѥåե饰: 1 ǥ; 0 ǥȤ
#ifdef TMD_DISABLE_HALIST
#define TMD00021_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00021_DISABLE_HALIST
TMD_EXTERN Integer tmd00021_flag;
#endif /* TMD00021_DISABLE_HALIST */

// ؿ
#if !defined(TMD_USER_MM) && !defined(TMD00021_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00021_DIVIDED_COMPILE)
#include TMD00021_MM
#else /* !(!TMD_USER_MM && !TMD00021_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00021_DIVIDED_COMPILE) */
void init_tmd00021(/* linear_flag, params_flag, */ ...); // require TMD00021_MM;
Matrix diff_tmd00021(/* t, x, u */); // require TMD00021_MM;
Matrix output_tmd00021(/* t, x, u */); // require TMD00021_MM;
#endif /* !TMD_USER_MM && !TMD00021_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00021_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00021_H */
